Refactor and add cache

This commit is contained in:
Santiago Lo Coco 2024-04-09 22:23:10 +02:00
parent 1ef1a7825b
commit f2c0820ef2
2 changed files with 111 additions and 91 deletions

View File

@ -13,7 +13,7 @@ $(INSTALL_PATH): cbattery
uninstall: uninstall:
@echo "Removing cbattery from $(DESTDIR)" @echo "Removing cbattery from $(DESTDIR)"
@$(DESTDIR)/cbattery revert || (echo "Reverting cbattery configurations failed"; exit 1) @su $(USER) -c '$(DESTDIR)/cbattery revert' || (echo "Reverting cbattery configurations failed"; exit 1)
@rm -f $(INSTALL_PATH) @rm -f $(INSTALL_PATH)
help: help:

128
cbattery
View File

@ -2,7 +2,9 @@
set -e set -e
function usage() { CACHE_FILE="${XDG_CACHE_HOME:-$HOME/.cache}/cbattery.status"
usage() {
cat << EOF cat << EOF
usage: ${0##*/} [command] usage: ${0##*/} [command]
charging [on|off] - Toggle charging charging [on|off] - Toggle charging
@ -14,48 +16,53 @@ usage: ${0##*/} [command]
EOF EOF
} }
function enable_discharging() { write_cache() {
echo "$1" > "$CACHE_FILE"
}
read_cache() {
cat "$CACHE_FILE" 2> /dev/null
}
enable_discharging() {
echo "Enabling battery discharging" echo "Enabling battery discharging"
sudo smc -k CH0I -w 01 sudo smc -k CH0I -w 01
} }
function disable_discharging() { disable_discharging() {
echo "Disabling battery discharging" echo "Disabling battery discharging"
sudo smc -k CH0I -w 00 sudo smc -k CH0I -w 00
} }
function enable_charging() { enable_charging() {
echo "Enabling battery charging" echo "Enabling battery charging"
sudo smc -k CH0B -w 00 sudo smc -k CH0B -w 00
sudo smc -k CH0C -w 00 sudo smc -k CH0C -w 00
disable_discharging disable_discharging
write_cache "enabled"
} }
function disable_charging() { disable_charging() {
echo "Disabling battery charging" echo "Disabling battery charging"
sudo smc -k CH0B -w 02 sudo smc -k CH0B -w 02
sudo smc -k CH0C -w 02 sudo smc -k CH0C -w 02
write_cache "disabled"
} }
function get_smc_charging_hex() { get_smc_charging_hex() {
smc -k CH0B -r | awk '{print $4}' | sed s:\):: smc -k CH0B -r | awk '{print $4}' | sed s:\)::
} }
function get_smc_charging_status() { get_smc_charging_status() {
hex_status=$(get_smc_charging_hex) hex_status=$(get_smc_charging_hex)
if [[ "$hex_status" == "00" ]]; then [[ "$hex_status" == "00" ]] && echo "enabled" || echo "disabled"
echo "enabled"
else
echo "disabled"
fi
} }
function get_battery_percentage() { get_battery_percentage() {
battery_percentage=$(pmset -g batt | tail -n1 | awk '{print $3}' | sed s:%\;::) pmset -g batt | awk 'END {print $3}' | sed 's/%;//'
echo "$battery_percentage"
} }
function install_visudo_file() { install_visudo_file() {
sudoers_file="/private/etc/sudoers.d/cbattery" sudoers_file="/private/etc/sudoers.d/cbattery"
if ! smc_loc="$(command -v smc)"; then if ! smc_loc="$(command -v smc)"; then
echo "'smc' is required but not found." echo "'smc' is required but not found."
@ -70,51 +77,64 @@ function install_visudo_file() {
sudo chmod 440 "$sudoers_file" sudo chmod 440 "$sudoers_file"
} }
get_cached_status() {
set +e
read_cache_result=$(read_cache)
read_cache_error=$?
set -e
if [ $read_cache_error -ne 0 ]; then
status=$(get_smc_charging_status)
write_cache "$status"
echo "$status"
else
echo "$read_cache_result"
fi
}
runScript() {
action=$1 action=$1
setting=$2 setting=$2
if [ -z "$action" ] || [[ "$action" == "help" ]]; then case "$action" in
"help" | "")
usage usage
exit 0 ;;
fi "revert")
if [[ "$action" == "revert" ]]; then
enable_charging enable_charging
disable_discharging disable_discharging
exit 0 ;;
fi "charging")
if [[ "$action" == "charging" ]]; then
echo "Setting $action to $setting" echo "Setting $action to $setting"
if [[ "$setting" == "on" ]]; then case "$setting" in
enable_charging "on") enable_charging ;;
elif [[ "$setting" == "off" ]]; then "off") disable_charging ;;
disable_charging *) echo "Invalid option: $setting" ;;
fi esac
exit 0 ;;
fi "adapter")
if [[ "$action" == "adapter" ]]; then
echo "Setting $action to $setting" echo "Setting $action to $setting"
if [[ "$setting" == "on" ]]; then case "$setting" in
enable_discharging "on") enable_discharging ;;
elif [[ "$setting" == "off" ]]; then "off") disable_discharging ;;
disable_discharging *) echo "Invalid option: $setting" ;;
fi esac
exit 0 ;;
fi "status")
case "$setting" in
if [[ "$action" == "status" ]]; then "charging") exit "$(get_smc_charging_hex)" ;;
if [[ "$setting" == "charging" ]]; then "cache") echo "$(get_cached_status)" ;;
exit "$(get_smc_charging_hex)" *) echo "Battery at $(get_battery_percentage)%, smc charging $(get_smc_charging_status)" ;;
else esac
echo "Battery at $(get_battery_percentage)%, smc charging $(get_smc_charging_status)" ;;
fi "visudo")
exit 0
fi
if [[ "$action" == "visudo" ]]; then
install_visudo_file install_visudo_file
exit 0 ;;
fi *)
echo "Invalid command: $action"
usage
;;
esac
}
runScript "$@"